package com.realnet.basicp1.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.basicp1.Entity.Types;
import com.realnet.basicp1.Services.TypesService ;




@RequestMapping(value = "/Types")
 @CrossOrigin("*") 
@RestController
public class TypesController {
	@Autowired
	private TypesService Service;

@Value("${projectPath}")
	private String projectPath;
 




	@PostMapping("/Types")
		  public Types Savedata(@RequestBody Types data) {
		Types save = Service.Savedata(data)	;



		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Types/{id}")
	public  Types update(@RequestBody Types data,@PathVariable Integer id ) {
		Types update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Types/getall/page")
	public Page<Types> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Types> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Types")
	public List<Types> getdetails() {
		 List<Types> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Types")
	public List<Types> getallwioutsec() {
		 List<Types> get = Service.getdetails();		
		return get;
}
@GetMapping("/Types/{id}")
	public  Types  getdetailsbyId(@PathVariable Integer id ) {
		Types  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Types/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}





}